$(document).ready(function(){

    $("#addNoteDiv").on('click', function() {
        createForm();
    })

    $('#allNotesDiv').on('click', 'button', function() {
        console.log("1")
        console.log(this)
        let buttonId = (this.id).split("saveNoteButton")[1];
        console.log(buttonId)
        saveNoteObject(buttonId);
    })
})

let id=0;

function createForm(){

    id++;
    let wrapper = document.createElement("div")
    wrapper.setAttribute('id', id)
    let inputsWrapper = document.createElement("div")
    inputsWrapper.setAttribute('class', "noteDiv");

    let input = document.createElement("input");
    input.setAttribute('type', "text");
    input.setAttribute('name',"noteTitle");
    input.setAttribute('id', "inputTitle"+id);
    input.setAttribute('placeholder', "Enter title...");
    input.style.marginBottom='5px';

    let div1 = document.createElement("div");
    let textarea = document.createElement("textarea");
    textarea.setAttribute('name',"noteText");
    textarea.setAttribute('id', "noteText"+id);
    textarea.setAttribute('placeholder', "Enter notes...");
    textarea.style.width='300px';
    textarea.style.height='150px';
    textarea.style.boxSizing='border-box';
    div1.appendChild(textarea);

    let div2 = document.createElement("div")
    div2.setAttribute('id', 'buttonDiv'+id)
    let btn = document.createElement("button");
    btn.setAttribute('type',"button");
    btn.setAttribute('id',"saveNoteButton"+id);
    btn.innerHTML = 'Save';

    inputsWrapper.appendChild(input);
    inputsWrapper.appendChild(div1);
    inputsWrapper.appendChild(btn);
    wrapper.appendChild(inputsWrapper);

    document.getElementById('allNotesDiv').appendChild(wrapper);
}

let ctr;

function sleep(ms) {
    return new Promise(resolve => setTimeout(resolve, ms));
  }

async function saveNoteObject(id){

    console.log(id)
    enableLoadingSign(id);
    await sleep(10000) //sleep simulates the remote server access or similar, 
                       //so instead of sleep would be e.g. saveToRemoteServer()...
                       //the leftover code of the async function is executed after the delay
    disableLoadingSign(id);
    
    let noteTitle = document.getElementById('inputTitle'+id).value;
    let noteText = document.getElementById('noteText'+id).value; 
    let noteObj = {
        idK: id,
        title: noteTitle,
        text: noteText
    };
    let noteObj_serialized = JSON.stringify(noteObj); //stringify noteObj so it is displayed properly when set to local Storage
    localStorage.setItem("noteObj", noteObj_serialized);

    console.log(noteObj_serialized)
}

function enableLoadingSign(id){
    createLoadingSign(id)
    document.getElementById('loadSign'+id).style.display = "block";
}

function disableLoadingSign(id){
    let sign = document.getElementById('loadSign'+id);
    sign.style.display = "none";
    sign.parentNode.removeChild(sign);
}

function createLoadingSign(id){

    let loadingSign = document.createElement('div');
    let loadingSignWrapper = document.createElement('div');
    loadingSign.setAttribute('class', 'loader')
    loadingSign.setAttribute('id', 'loadSign'+id);
    loadingSignWrapper.appendChild(loadingSign);
    document.getElementById(id).appendChild(loadingSignWrapper);
}














